if Network:is_client() then
	return
end

_G.peer_ping_data = {}
_G.peer_ping_time = 0

Hooks:PostHook(NetworkManager, 'update', 'KickHighPingPlayers_ping',
function(self, t)
	if not self._session then return end
	if t > _G.peer_ping_time then
		local max_ping = 150
		for _, peer in pairs(self._session:peers()) do
			if not table.has(_G.peer_ping_data, peer:name()) then
				_G.peer_ping_data[peer:name()] = {}
				_G.peer_ping_data[peer:name()].median = 0
				_G.peer_ping_data[peer:name()].record = {}
			end
			if peer:synched() then
				local ping = Network:qos(peer:rpc()).ping
				table.insert(_G.peer_ping_data[peer:name()].record, ping)
				if #_G.peer_ping_data[peer:name()].record > 15 then
					table.remove(_G.peer_ping_data[peer:name()].record, 1)
					local list = clone(_G.peer_ping_data[peer:name()].record)
					table.sort(list)
					_G.peer_ping_data[peer:name()].median = list[8]
					if _G.peer_ping_data[peer:name()].median > max_ping then
						managers.chat:feed_system_message(ChatManager.GAME, peer:name() .. ' exceeded ping limit.')
						self._session:send_to_peers('kick_peer', peer:id(), 1)
						self._session:on_peer_kicked(peer, peer:id(), 1)
					end
				end
			end
		end
		_G.peer_ping_time = t + 2
	end
end)